Index: apps/app_stack.c
===================================================================
--- apps/app_stack.c	(revision 16081)
+++ apps/app_stack.c	(working copy)
@@ -122,8 +122,7 @@
 
 static int gosubif_exec(struct ast_channel *chan, void *data)
 {
-	struct localuser *u;
-	char *condition="", *label1, *label2, *args;
+	char *condition="", *label, *label1, *label2, *args;
 	int res=0;
 
 	if (ast_strlen_zero(data)) {
@@ -134,21 +133,15 @@
 	if (!(args = ast_strdupa(data)))
 		return -1;
 
-	LOCAL_USER_ADD(u);
-
 	condition = strsep(&args, "?");
 	label1 = strsep(&args, ":");
 	label2 = args;
 
-	if (ast_true(condition)) {
-		if (label1) {
-			res = gosub_exec(chan, label1);
-		}
-	} else if (label2) {
-		res = gosub_exec(chan, label2);
-	}
+	label = ast_true(condition) ? label1 : label2;
 
-	LOCAL_USER_REMOVE(u);
+	if (!ast_strlen_zero(label))
+		res = gosub_exec(chan, label);
+
 	return res;
 }
 
